String serialPort="COM3" ;


String inString;  // Input string from serial port:

Serial myPort;       

static final int lf = 10;  

void RS232setup() {
  // List all the available serial ports:
  print("available ports are:") ;
  println(Serial.list());
   
  myPort = new Serial(this,serialPort, 115200,'N',8,1.0);
  //myPort.bufferUntil(lf);
  checkConnectionAndDownload() ;
  }
  
  
void checkConnectionAndDownload(){

  println("check connection") ;
  print("clear buffer:") ;  String buffer=getAnswer() ; println("["+buffer+"]") ;
  RS232send("112233445567x") ; 
  print("Answer to x=") ;  
  String answer=getAnswer() ;
  println("["+answer+"]") ;
  String answer1=" <112233445567 123400000035 5567>" ;
  print("Expected   =") ;
  println("["+answer1+"]") ;
  
  
  int k=0 ;
  boolean ok=true ;
  print("check[") ;
  for(k=0 ; k<14+19 ; k++){
    print(answer.charAt(k)) ;
    if(answer.charAt(k)!=answer1.charAt(k) ) { ok=false ; break ; }
    }
  println("] end check") ;  
  if(!ok){ println("connection not ok") ;  exit() ; }  
  if(ok) { println("connection is ok!") ;  }

  
 
 downLoadDDS() ;
  println("download ok") ;
  getAnswer() ;
   
  int errorCount=0 ;
  }
 
  int nSamples=4096;
  long L32=1L<<32L;
    
  void downLoadDDS(){
 
 
  
   double frq=1.1e6 ;
   int dPhase =(int)(frq*L32/150.0e6) ;
   //RS232send(String.format("00%08Xu",dPhase)) ;
   //RS232send(String.format("00100000u",dPhase)) ;
   RS232send(String.format("00001000u",dPhase)) ;
   
 
   for(int k=0 ; k<nSamples ; k++){
     int address=k ;
     int data=(int)(2048+2040*cos(2*PI*k/nSamples)) ;
     RS232send(String.format("%04X%04Xs",address,data) ) ;
     }
   }

void updateFrequency(){
 
  double d=getFloat(userTB.Text) ;
  println("text=["+userTB.Text+"] "+d) ;
  int dPhase =(int)(d*L32/150.0e6) ;
  RS232send(String.format("00%08Xu",dPhase)) ;
  }


  int indexOfSetTable=0 ;
  
  void doButton1(){
    updateFrequency() ;
    if(indexOfSetTable!=1){
      print("set table sine") ;
      for(int k=0 ; k<nSamples ; k++){
        int address=k ;
        int data=(int)(2048+2040*cos(2*PI*k/nSamples)) ;
        RS232send(String.format("%04X%04Xs",address,data) ) ;
        }
      println(" ready") ;  
      indexOfSetTable=1 ;
      }  
    }
  
  void doButton2(){
    updateFrequency() ;
    if(indexOfSetTable!=2){
      print("set table rect ") ;
      for(int k=0 ; k<nSamples ; k++){
        int address=k ;
        int data=0 ;
        if(k<2048) { data=0 ; } else { data=4095 ; }
        RS232send(String.format("%04X%04Xs",address,data) ) ;
        }
      println(" ready") ;  
      indexOfSetTable=2 ;
      } 
      
    }
  
  void doButton3(){
    updateFrequency() ;
    if(indexOfSetTable!=3){
      print("set table triangle ") ;
      for(int k=0 ; k<nSamples ; k++){
        int address=k ;
        int data=0 ;
        if(k<2048) { data=2*k ; } else { data=8192-2*k ; }
        RS232send(String.format("%04X%04Xs",address,data) ) ;
        }
      println(" ready") ;  
      indexOfSetTable=3 ;
      } 
    }
    
  void doButton4(){
      RS232send(String.format("0000000010u")) ;
    if(indexOfSetTable!=4){
      print("set table test ") ;
      for(int k=0 ; k<nSamples ; k++){
        int address=k ;
        int data=0 ;
        if( (k&1)==1){ data=0 ; } else { data=4095 ; }
        RS232send(String.format("%04X%04Xs",address,data) ) ;
        }
      println(" ready") ;  
      indexOfSetTable=4 ;
      } 
    }    

String getAnswer(){
  return getAnswer(10) ;
  }

String getAnswer(int maxTries){
  int timeOut ;
  String answer ;
  answer="" ;
  timeOut=0 ;
  do{
    while (myPort.available() > 0) { 
      int inByte = myPort.read();
      if(inByte>=32){ answer=answer+(char)inByte ;}
      timeOut=0 ;
      }
    try { Thread.sleep(1); } catch (Exception e) { System.out.println(e);}
    timeOut++ ;
    } while(timeOut<maxTries) ;
 // println("answer=["+answer+"]") ;
  return answer ;
  }
  




boolean isNum(char c){
  if (('0'<=c) & (c<='9')) { return true ; }
  return false ;
  }
  
int hexVal(char c){
  if (('0'<=c) & (c<='9')) { return c-'0' ; }
  if (('A'<=c) & (c<='F')) { return c-'A'+10 ; }
  if (('a'<=c) & (c<='f')) { return c-'A'+10 ; }
  return 0 ;
  }  
int One=1 ;

 
void RS232send(String s){
  if(One==1){
    myPort.write(s) ;
   // println("TX ["+s+"]") ;
  }
  else{
    for(int k=0 ; k<s.length() ; k++){
      myPort.write(s.charAt(k)) ;
      print(s.charAt(k)) ;
      try { Thread.sleep(1); } catch (Exception e) { System.out.println(e);}
      }
    println() ;
    }
  }
    